<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use \Teknisa\CDP\Controllers\TeknisaCrud;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class cdp00100ParametrosControleProducaoController extends TeknisaCrud {
        protected $dataSourceName = '';
        protected $dataSourceNameToSave = 'obspadordpro';
        protected $dataSourceNameToFind = 'Obspadordpro_controleProducao_select_txt';
  
        public function __construct($crudService, ParameterBag $parameterBag){
            parent::__construct($crudService, $parameterBag);
        }
        
        public function SaveObspadordpro(DTO\Request $request, DTO\Response $response) {
            $row = $request->getRow();
    	    $row["TXOBSORDPRO"] = bin2hex($row["TXOBSORDPRO"]);
            $newRequest = new DTO\Request\Row ($row, '', '', '');
    	    try{
    	        if(mb_strlen($row["TXOBSORDPRO"]) > 4000){
    	            $response->setError(new Error('O texto inserido é maior que o permitido', 0));
    	        } else {
    	            $this->dataSourceName = $this->dataSourceNameToSave;
    	            parent::save($newRequest, $response);
    	        }
    	    } catch(\Exception $e){
    	        $response->setError(new Error($e->getMessage(), 500));
    	    }
	    }
	    
	    public function SelectObspadordpro( DTO\Request\Filter $request, DTO\Response $response) {
    	    try{
    	        $this->dataSourceName = $this->dataSourceNameToFind;
                parent::find($request, $response);
    	    } catch (\Exception $e){
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
	    }
        
    }
?>