<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

use \Teknisa\GER\Libraries\PHPMailer;
use Teknisa\CDP\Controllers\TeknisaCrud;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;

class cdp06400PontosCriticosController extends TeknisaCrud {
    protected $dataSourceName = 'inspecao';
    protected $dataSourceNameToSave = '';
    protected $cdp06400PontosCriticosService;

    public function __construct($crudService, ParameterBag $parameterBag, $cdp06400PontosCriticosService){
        parent::__construct($crudService, $parameterBag);
        $this->cdp06400PontosCriticosService = $cdp06400PontosCriticosService;
    }

    public function incrementarCodigo(DTO\Request $request, DTO\Response $response){
        try {
            $rows = $request->getRow();
            $cdinspecao = $this->cdp06400PontosCriticosService->incrementeCodigo($rows);
            $response->addDataSet(new DataSet("result", $cdinspecao));


        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
}
?>