<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use \Teknisa\GER\Libraries\PHPMailer;
    use Teknisa\CDP\Controllers\TeknisaCrud;
    use Teknisa\GER\Controllers\CrudController;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;
    use Teknisa\CDP\Modules\Producao\Services\cdp26000ControlePrioridadeProducaoService;

    class cdp26000ControlePrioridadeProducaoController extends TeknisaCrud {
        protected $cdp26000ControlePrioridadeProducaoService;
  
        public function __construct($crudService, ParameterBag $parameterBag, cdp26000ControlePrioridadeProducaoService $cdp26000ControlePrioridadeProducaoService){
            parent::__construct($crudService, $parameterBag);
            $this->cdp26000ControlePrioridadeProducaoService = $cdp26000ControlePrioridadeProducaoService;
        }
	    
	    public function checkNewRowPrioriproducao(DTO\Request $request, DTO\Response $response) {
            $row = $request->getRow();
    	    try{
                $existe = $this->cdp26000ControlePrioridadeProducaoService->checkNewRowPrioriproducao($row);
                
                $response->addDataSet(new dataSet("checkNewRowPrioriproducao", [$existe]));

    	    } catch (\Exception $e){
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
	    }
        
    }
?>