<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class Cdp04000AgendaDeTarefasFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function deleteTabelaInspecao($nrorg, $cdfilial, $cdsetor, $cdperientr, $hragentare, $idorigagtare){
        try {
            
            $sql = "DELETE FROM INSPAGENTARE
                    WHERE NRORG     = :NRORG AND
                        CDFILIAL    = :CDFILIAL AND
                        CDSETOR     = :CDSETOR AND
                        CDPERIENTR  = :CDPERIENTR AND
                        HRAGENTARE   = :HRAGENTARE AND
                        IDORIGAGTARE   = :IDORIGAGTARE";

            $params = array(
                'NRORG'=>$nrorg,
                'CDFILIAL'=>$cdfilial,
                'CDSETOR'=>$cdsetor,
                'CDPERIENTR'=>$cdperientr,
                'HRAGENTARE'=>$hragentare,
                'IDORIGAGTARE'=>$idorigagtare
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteTabelaAgenda($nrorg, $cdfilial, $cdsetor, $cdperientr, $hragentare, $idorigagtare){
        
        try {
         
            $sql = "DELETE FROM AGENTARE
                    WHERE NRORG     = :NRORG AND
                        CDFILIAL    = :CDFILIAL AND
                        CDSETOR     = :CDSETOR AND
                        CDPERIENTR  = :CDPERIENTR AND
                        HRAGENTARE   = :HRAGENTARE AND
                        IDORIGAGTARE   = :IDORIGAGTARE";

            $params = array(
                'NRORG'=>$nrorg,
                'CDFILIAL'=>$cdfilial,
                'CDSETOR'=>$cdsetor,
                'CDPERIENTR'=>$cdperientr,
                'HRAGENTARE'=>$hragentare,
                'IDORIGAGTARE'=>$idorigagtare
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
     
    }
    
    public function UpdateAgenda($nrorg, $cdfilial, $cdsetor, $cdperientr, $hragentare, $idorigagtare,$cdequippro,$dsagentare, $idorigagtare2){
        try{
            $sql = "UPDATE AGENTARE
                        SET IDORIGAGTARE   = :IDORIGAGTARE,
                        CDEQUIPPRO = :CDEQUIPPRO,
                        DSAGENTARE = :DSAGENTARE
                        WHERE NRORG     = :NRORG AND
                        CDFILIAL    = :CDFILIAL AND
                        CDSETOR     = :CDSETOR AND
                        CDPERIENTR  = :CDPERIENTR AND
                        HRAGENTARE   = :HRAGENTARE AND
                        IDORIGAGTARE   = :IDORIGAGTARE2";
    
            $params = array(
                'NRORG'=>$nrorg,
                'CDFILIAL'=>$cdfilial,
                'CDSETOR'=>$cdsetor,
                'CDPERIENTR'=>$cdperientr,
                'HRAGENTARE'=>$hragentare,
                'IDORIGAGTARE'=>$idorigagtare,
                'CDEQUIPPRO'=>$cdequippro,
                'DSAGENTARE'=>$dsagentare,
                'IDORIGAGTARE2'=>$idorigagtare2
            );
    
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
    	       throw new \Exception($e->getMessage(),1);
        }
    }
    
    public function verificaInspecao($nrorg, $idorigagtare){
        
        $sql = "SELECT *FROM INSPECAO
                    WHERE NRORG     = :NRORG AND
                    IDORIGINSPEC   = :IDORIGAGTARE";
                    
        $params = array(
            'NRORG'=>$nrorg,
            'IDORIGAGTARE'=>$idorigagtare
        );
        
       
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetch();
    }
    
}