<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class cdp01300OcorrenciaDaProducaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function deleteTabelaOcorrencia($nrorg,$cdgrupocor){
        try {
         
            $sql = "DELETE FROM OCORRENCIA
                    WHERE NRORG = :NRORG AND
                        CDGRPOCOR    = :CDGRPOCOR";

            $params = array(
                'NRORG'=>$nrorg,
                'CDGRPOCOR'=>$cdgrupocor
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteTabelaGrupoOcorrencia($nrorg,$cdgrupocor){
        try {
         
            $sql = "DELETE FROM GRUPOCOR
                    WHERE NRORG = :NRORG AND
                         CDGRPOCOR = :CDGRPOCOR";

            $params = array(
                'NRORG'=>$nrorg,
                'CDGRPOCOR'=>$cdgrupocor
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
}

