<?php
namespace Teknisa\CDP\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Geral\Util\DateUtil;
use Teknisa\Model\Pedidosexpedicao\Entities\Agendavendedor;
use Teknisa\CDP\Factories\qpr01900InspecaoDigitalFactory;

class qpr01900InspecaoDigitalService {
    
    protected $entityManager;
    protected $environment;
    protected $newCode;
    protected $InspecaoFactory;
    
    
    public function __construct(EntityManager $entityManager, Environment $environment, NewCode $newCode, $InspecaoFactory)
    {        
        $this->entityManager                       = $entityManager;
        $this->environment                         = $environment;
        $this->newCode                             = $newCode;
        $this->InspecaoFactory                     = $InspecaoFactory;        
    }
    
    public function getNrOrg() {
        return $this->environment->getNrOrgTrab();
    }
    
    public function searchTarefaQuestao($params) {
        $nrorg = $this->environment->getNrOrgTrab();
        $cdoperador = $params[0];
        $datainicio = $params[1];
        $datafinal = $params[2];
        $result = array();
        $result['questao'] = array();
        $result['tarefa'] = $this->InspecaoFactory->searchInspecaoTarefa($nrorg, $cdoperador, $datainicio, $datafinal);
        
        if(!$result['tarefa']) {
            $cdchecklist = [];
        }
        
        foreach ($result['tarefa'] as $value) {
            $cdchecklist = $value['CDCHECKLIST'];
            $nrordprod = $value['NRORDPROD'];
            $nrsubordprod = $value['NRSUBORDPROD'];
            $cdinspecao = $value['CDINSPECAO'];
            $nrauditoria = $value['NRAUDITORIA'];
            $result['questao'][] = $this->InspecaoFactory->searchInspecaoQuestaoParam($nrorg, $cdchecklist, $nrordprod, $nrsubordprod, $cdinspecao, $nrauditoria);
        }
        
        $saida = array();
        foreach ($result['questao'] as $questao) {
            foreach($questao as $value) {
                array_push($saida, $value);
            }
        }
        $result['questao'] = $saida;
        if($result['tarefa']){
            $result['respostaVal'] = $this->InspecaoFactory->searchRespVal($nrorg, $cdchecklist);
            $result['respostaBool'] = $this->InspecaoFactory->searchRespBool($nrorg, $cdchecklist);
            $result['respostaCad'] = $this->InspecaoFactory->searchRespCad($nrorg, $cdchecklist);
            $result['respQuestVisBoo'] = $this->InspecaoFactory->searchVisBooQuestResp($nrorg, $cdchecklist);
            $result['respQuestVar'] = $this->InspecaoFactory->searchVarQuestResp($nrorg, $cdchecklist);
            $result['respQuestCad'] = $this->InspecaoFactory->searchCadQuestResp($nrorg, $cdchecklist);
        };
        return $result;
    }

}